#include <iostream>
#include <vector>
#include <map>
#include <queue>

enum LIFT_STATES {
	WAIT,
	ACTIVE,
	DOWN
};

struct Person {
	int index;
	int time;
	int floor;
	int exitTime;
};

std::multimap<int, Person> readPeople(int count) {
	std::multimap<int, Person> res;
	for (int i = 0; i < count; i++) {
		int t, a;
		std::cin >> t >> a;
		res.insert(std::pair<int, Person>(t, Person{ i, t, a }));
	}
	return res;
}

int main() {
	int time = 1;
	int liftPosition = 1;
	LIFT_STATES liftState = WAIT;
	int liftTargetFloor = -1;

	int m, n;
	std::cin >> n >> m;

	auto people = readPeople(n);

	std::multimap<int, Person> activePeople;
	std::map<int, Person> output;
	std::vector<Person> inLift;
	while (true) {
		if (liftState == DOWN) {
			auto onCurrentFloorRange = activePeople.equal_range(liftPosition);
			if (onCurrentFloorRange.first != onCurrentFloorRange.second) {
				for (auto i = onCurrentFloorRange.first; i != onCurrentFloorRange.second; i++) {
					inLift.push_back(i->second);
				}
				activePeople.erase(liftPosition);
			}
		}

		if (liftPosition == 1 && liftState == DOWN) {
			for (auto p : inLift) {
				p.exitTime = time;
				output.insert(std::pair<int, Person>(p.index, p));
			}
			inLift.clear();
			if (output.size() == n) {
				break;
			}

			if (activePeople.size() == 0) {
				liftState = WAIT;
			}
			else {
				liftState = ACTIVE;
				int mt = 1000000001;
				for (auto p : activePeople) {
					if (p.second.time < mt) {
						mt = p.second.time;
						liftTargetFloor = p.second.floor;
					}
				}
			}
		}

		if (liftState == ACTIVE && liftPosition == liftTargetFloor) {
			auto onCurrentFloorRange = activePeople.equal_range(liftPosition);
			if (onCurrentFloorRange.first != onCurrentFloorRange.second) {
				for (auto i = onCurrentFloorRange.first; i != onCurrentFloorRange.second; i++) {
					inLift.push_back(i->second);
				}
				activePeople.erase(liftPosition);
				liftTargetFloor = 1;
				liftState = DOWN;
			}
		}

		auto currentPeopleRange = people.equal_range(time);
		if (currentPeopleRange.first != currentPeopleRange.second) {
			for (auto i = currentPeopleRange.first; i != currentPeopleRange.second; i++) {
				if (liftState == WAIT) {
					liftState = ACTIVE;
					liftTargetFloor = i->second.floor;
				}
				if (liftState == DOWN && i->second.floor == liftPosition) {
					inLift.push_back(i->second);
				}
				else {
					activePeople.insert(std::pair<int, Person>(i->second.floor, i->second));
				}
			}
		}

		if (liftState != WAIT) {
			liftTargetFloor > liftPosition ? liftPosition++ : liftPosition--;
		}
		time++;
	}

	for (auto p : output) {
		std::cout << p.second.exitTime << std::endl;;
	}

	system("pause");
	return 0;
}